#include <iostream>

const int MAXN = 5e3 + 10;

int pref[MAXN][MAXN];

bool check(int x, int k, int n)
{
	for(int i = x; i <= n; ++ i)
	{
		for(int j = x; j <= n; ++ j)
		{
			if(pref[i][j] - pref[i - x][j] - pref[i][j - x] + pref[i - x][j - x] < k)
			{
				return false;
			}
		}
	}

	return true;
}

int main()
{

	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	int n, k;
	std::cin >> n >> k;

	for(int i = 1; i <= n; ++ i)
	{
		for(int j = 1; j <= n; ++ j)
		{
			int curr;
			std::cin >> curr;
			pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + curr;
		}
	}

	int l = 0, r = n;

	while(r > l + 1)
	{
		int mid = (l + r) / 2;
		if(check(mid, k, n))
		{
			r = mid;
		}else
		{
			l = mid;
		}
	}

	if(!check(r, k, n))
	{
		std::cout << "-1\n";
	}else
	{
		std::cout << r << '\n';
	}

	return 0;
}