#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int h[MAXN + 5];
int L[MAXN + 5], R[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N;
    cin >> N;

    int fmax = 0, lmax = 0;
    for (int i = 1; i <= N; ++ i)
    {
        cin >> h[i];
        if (h[fmax] < h[i]) fmax = i;
        if (h[lmax] <= h[i]) lmax = i;
    }

    int K;
    cin >> K;

    int ans = 0;
    int idx, hh;
    for (int i = 0; i < K; ++ i)
    {
        cin >> idx >> hh;
        idx++;
        h[idx] += hh;
        if (h[fmax] < h[idx]) fmax = idx;
        if (h[lmax] <= h[idx]) lmax = idx;
        ans++;
    }

    h[0] = h[N + 1] = 2 * MAXN + 5;
    stack<int> st;
    st.push(0);
    for (int i = 1; i <= N; ++ i)
    {
        while (h[st.top()] < h[i]) st.pop();
        L[i] = st.top();
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(N + 1);

    for (int i = N; i >= 1; -- i)
    {
        while (h[st.top()] <= h[i]) st.pop();
        R[i] = st.top();
        st.push(i);
    }

    unsigned long long int area = 0;

    int i = 1;
    while (R[i] != N + 1)
    {
        area += h[i] * (R[i] - i);
        i = R[i];
    }

    int j = N;
    while (j != i)
    {
        area += h[j] * (j - L[j]);
        j = L[j];
    }

    cout << ans - 1 << " " << area << endl;

    return 0;
}
