#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(int i = a; i <= b; ++i)

struct barrier
{
    int height, max_increase;
    bool is_inner;
};

int calculate_water(const std::vector<barrier>& barriers)
{
    auto sum = 0;

    for(auto it = barriers.begin(); it != std::prev(barriers.end()); ++it) {
        auto next = std::next(it);

        barrier max_barrier, min_barrier;
        if(it->height > next->height) {
            max_barrier = *it;
            min_barrier = *next;
        } else {
            max_barrier = *next;
            min_barrier = *it;
        }

        if(min_barrier.is_inner) {
            sum += max_barrier.height;
        } else {
            sum += min_barrier.height;
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n;
    std::cin >> n;

    std::vector<barrier> heights(n);

    int h;
    range(i, 0, n-1) {
        std::cin >> h;
        heights[i] = {h, -1, false};
    }

    int k;
    std::cin >> k;

    int idx;
    range(i, 0, k-1) {
        std::cin >> idx >> h;
        heights[idx].max_increase = h;
    }

    for(auto it = std::next(heights.begin()); it != std::prev(heights.end()); ++it)
    {
        auto prev = std::prev(it);
        auto next = std::next(it);

        if(prev->height >= it->height && next->height >= it->height) {
            it->is_inner = true;
        }
    }

    auto answer = 0;

    for(auto &val : heights) {
        if(val.max_increase == -1 || val.is_inner) {
            continue;
        }

        val.height += val.max_increase;
        ++answer;
    }

    auto end_water = calculate_water(heights);

    std::cout << answer << " " << end_water << endl;

    return 0;
}
