#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(int i = a; i <= b; ++i)

struct barrier
{
    int idx, height, max_increase;
    bool is_inner;
};

int calculate_water(const std::vector<barrier>& barriers)
{
    auto sum = 0;

    for(auto it = barriers.begin(); it != std::prev(barriers.end()); ++it) {
        auto next = std::next(it);

        barrier max_barrier, min_barrier;
        if(it->height > next->height) {
            max_barrier = *it;
            min_barrier = *next;
        } else {
            max_barrier = *next;
            min_barrier = *it;
        }

        if(min_barrier.is_inner) {
            sum += max_barrier.height;
        } else {
            sum += min_barrier.height;
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n;
    std::cin >> n;

    std::vector<barrier> heights(n);

    int h;
    range(i, 0, n-1) {
        std::cin >> h;
        heights[i] = {i, h, -1, false};
    }

    int k;
    std::cin >> k;

    int idx;
    range(i, 0, k-1) {
        std::cin >> idx >> h;
        heights[idx].max_increase = h;
    }

    for(auto it = std::next(heights.begin()); it != std::prev(heights.end()); ++it)
    {
        auto prev = std::prev(it);
        auto next = std::next(it);

        if(prev->height >= it->height && next->height >= it->height) {
            it->is_inner = true;
        }
    }

    std::vector<barrier> changeable(k);
    std::copy_if(heights.begin(), heights.end(), changeable.begin(),
        [](const barrier& val) {
            return val.max_increase != -1;
        });

    auto max_water = 0;
    auto min_k = 0;
    range(i, 1, k) {
        range(start, 0, k-i) {
            range(x, start, start+i-1) {
                auto b = changeable[x];
                heights[b.idx].height += b.max_increase;
            }

            auto curr_water = calculate_water(heights);
            if(curr_water > max_water) {
                max_water = curr_water;
                min_k = i;
            }

            range(x, start, start+i-1) {
                auto b = changeable[x];
                heights[b.idx].height = b.height;
            }
        }
    }

    std::cout << min_k << " " << max_water << endl;

    return 0;
}
