#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(int i = a; i < b; ++i)

std::unordered_map<int, int> count;

struct barrier
{
    int idx, height, max_increase;

    bool operator<(const barrier& other) {
        return this->idx < other.idx;
    }
};

int calculate_water(const std::vector<barrier>& b)
{
    auto sum = 0;

    for(auto it = b.begin(); it != std::prev(b.end()); ) {
        auto n = std::next(it);

        auto found = false;

        if(count[it->height] > 1) {
            found = true;

            while(n->height != it->height) {
                if(n->height > it->height || n == b.end()) {
                    found = false;
                    break;
                }

                n = std::next(n);
            }

            if(!found) {
                n = std::next(it);
            }
        }

        auto delta = n->idx - it->idx;

        auto min_height = std::min(it->height, n->height) * delta;
        sum += min_height;
        if(found) {
            it = n;
        } else {
            it = std::next(it);
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n;
    std::cin >> n;

    std::vector<barrier> heights(n);

    int h;
    range(i, 0, n) {
        std::cin >> h;
        ++count[h];
        heights[i] = {i, h, -1};
    }

    int k;
    std::cin >> k;

    int idx;
    range(i, 0, k) {
        std::cin >> idx >> h;
        heights[idx].max_increase = h;
    }

    // Copy only the barriers we can change to a separate vector
    std::vector<barrier> changeable(k);

    std::copy_if(heights.begin(), heights.end(), changeable.begin(),
        [](const barrier& val) {
            return val.max_increase != -1;
        });

    auto max_water = calculate_water(heights);
    auto min_k = 0;

    range(i, 1, k+1) {
        do
        {
            range(j, 0, i) {
                auto b = changeable[j];
                heights[b.idx].height += b.max_increase;
            }

            auto curr_water = calculate_water(heights);
            if(curr_water > max_water) {
                max_water = curr_water;
                min_k = i;
            }

            range(j, 0, i) {
                auto b = changeable[j];
                heights[b.idx].height = b.height;
            }
        } while(std::next_permutation(changeable.begin(), changeable.end()));
    }

    std::cout << min_k << " " << max_water << endl;

    return 0;
}
