#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(int i = a; i < b; ++i)

struct barrier
{
    int idx, height, max_increase;

    bool operator<(const barrier& other) {
        return this->idx < other.idx;
    }
};

int calculate_water(const std::vector<barrier>& b)
{
    auto sum = 0;

    for(auto it = b.begin(); it != std::prev(b.end()); ) {
        auto n = std::next(it);


           auto found = true;

            while(n->height != it->height) {
                if(n->height > it->height || n == b.end()) {
                    found = false;
                    break;
                }

                n = std::next(n);
            }

            if(!found) {
                n = std::next(it);
            }

        auto delta = n->idx - it->idx;

        auto min_height = std::min(it->height, n->height) * delta;
        sum += min_height;
        if(found) {
            it = n;
        } else {
            it = std::next(it);
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n;
    std::cin >> n;

    std::vector<barrier> heights(n);

    int h;
    range(i, 0, n) {
        std::cin >> h;
        heights[i] = {i, h, -1};
    }

    int k;
    std::cin >> k;

    std::vector<barrier> changeable;

    int idx;
    range(i, 0, k) {
        std::cin >> idx >> h;
        heights[idx].max_increase = h;

        changeable.emplace_back(heights[idx]);
    }

    auto max_water = 0;
    auto min_k = 10000000;

    do {
        range(i, 1, k+1) {
            range(j, 0, i) {
                auto b = changeable[j];
                heights[b.idx].height += b.max_increase;
            }

            auto curr_water = calculate_water(heights);
            if(curr_water > max_water && i <= min_k) {
                max_water = curr_water;
                min_k = i;
            }

            range(j, 0, i) {
                auto b = changeable[j];
                heights[b.idx].height = b.height;
            }
        }
    } while(std::next_permutation(changeable.begin(), changeable.end()));

    std::cout << min_k << " " << max_water << endl;

    return 0;
}
