#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

struct Number {
  int nr;
  int a[105];
  Number(int num) {
    nr = 0;
    memset(a, 0, sizeof(a));
    while(num)
      a[++nr] = num % 10, num /= 10;
  }
  Number() {
    nr = 0;
    memset(a, 0, sizeof(a));
  }
  Number operator + (const Number &other) const {
    Number ans = Number();
    int t = 0, i;
    for(i = 1; i <= nr || i <= other.nr || t; i++, t /= 10) {
      t += a[i] + other.a[i];
      ans.a[i] = t % 10;
    }
    ans.nr = i - 1;
    return ans;
  }
};

long long x, y, z, A, B;

Number dp[2005][2005];

Number getAns(long long x, long long y, long long A, long long B) {
  Number ans = 0;
  if(x < B || y < A) {
    return (Number)1;
  }
  if(dp[x][y].nr)
    return dp[x][y];
  for(int i = 1; i <= x / B && i <= y / A; i++)
    ans = ans + getAns(i * B, i * A, B, A);
  dp[x][y] = dp[y][x] = ans;
  return ans;
}

int main() {
  cin >> x >> y;
  z = __gcd(x, y);
  if(z == 1 || x == y) {
    cout << 0;
    return 0;
  }
  A = x / z, B = y / z;
  Number sol = getAns(x, y, A, B);
  for(int i = sol.nr; i >= 1; i--)
    cout << sol.a[i];
  return 0;
}
