#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll N = (ll) 1e6 + 7;
ll n;
ll q;
ll h[N];
ll grow[N];
ll ans = 0;
vector<ll> a;
vector<ll> b;

void compute_vecs()
{
    ll mx = -1;
    for (ll i = 1; i <= n; i++)
    {
        if (h[i] > mx)
        {
            mx = h[i];
            a.push_back(i);
        }
    }
    mx = -1;
    for (ll i = n; i >= 1; i--)
    {
        if (h[i] > mx)
        {
            mx = h[i];
            b.push_back(i);
        }
    }
    reverse(b.begin(), b.end());
}

ll calc_cost()
{
    ll cost = 0;
    for (ll i = 0; i + 1 < (ll) a.size(); i++)
    {
        cost += grow[a[i]];
    }
    for (ll i = 1; i < (ll) b.size(); i++)
    {
        cost += grow[b[i]];
    }
    if (a.back() == b[0])
    {
        ll p = a.back();
        ll mx2 = 0;
        for (ll i = 1; i <= n; i++)
        {
            if (h[i] != h[p])
            {
                mx2 = max(mx2, h[i]);
            }
        }
        ll init = h[p] - grow[p];
        ll now = max(mx2, init);
        cost += now - init;
        return 0LL;
    }
    else
    {
        cost += grow[a.back()];
        cost += grow[b[0]];
    }
    return cost;
}

ll calc_ans()
{
    ll ans = 0;
    for (ll i = 0; i + 1 < (ll) a.size(); i++)
    {
        ans += (ll) h[a[i]] * (a[i + 1] - a[i]);
    }
    ans += (ll) h[a.back()] * (b[0] - a.back());
    for (ll i = 0; i + 1 < (ll) b.size(); i++)
    {
        ans += (ll) h[b[i + 1]] * (b[i + 1] - b[i]);
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

  ///  freopen ("input", "r", stdin);
    cin >> n;
    for (ll i = 1; i <= n; i++)
    {
        cin >> h[i];
    }
    cin >> q;
    for (ll i = 1; i <= q; i++)
    {
        ll p, x;
        cin >> p >> x;
        p++;
        grow[p] += x;
        h[p] += x;
    }
    compute_vecs();
    ll cost = calc_cost();
    ll ans = calc_ans();
    cout << cost << " " << ans << "\n";

}
