#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>

#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;

const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 5000;


int a[maxn][maxn];
int prefix[maxn + 1][maxn + 1];

int get_sum(int x1, int y1, int x2, int y2){
    return prefix[x2][y2] - prefix[x2][y1] - prefix[x1][y2] + prefix[x1][y1];
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            cin >> a[i][j];
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            prefix[i][j] = prefix[i][j - 1] + a[i - 1][j - 1];
        }
    }
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= n; ++j){
            prefix[i][j] += prefix[i - 1][j];
//            cerr << prefix[i][j] << " ";
        }
//        cerr << endl;
    }
    int l = 0, r = n + 1;
    while(l + 1 < r){
        int m = (l + r) / 2;
        bool good = true;
        for(int i = 0; i <= n - m; ++i){
            for(int j = 0; j <= n - m; ++j) {
                int sum = get_sum(i, j, i + m, j + m);
//                cerr << "sum " << i << " " << j << ": " << sum << endl;
                if(sum < k){
                    good = false;
                }
            }
        }
        if(!good){
            l = m;
        }else{
            r = m;
        }
    }
    if(r == n + 1){
        cout << -1;
    }else{
        cout << r;
    }
}
