#include <iostream>

using namespace std;

const int maxn = 5005;
int table[maxn][maxn];

long long row[maxn][maxn];  /// can be int

long long rectangle[maxn][maxn];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, minSum;
    cin >> n >> minSum;

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            int note;
            cin >> note;
            table[i][j] = note;
        }
    }

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(j==0){
                row[i][0] = table[i][0];
            }
            else{
                row[i][j] = row[i][j-1] + table[i][j];
            }
            //cout << "row[ " << i << " ][ " << j << " ] = " << row[i][j] << endl;
        }
    }

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(i==0){
                rectangle[0][j] = row[0][j];
            }
            else{
                rectangle[i][j] = rectangle[i-1][j] + row[i][j];
            }
            //cout << "rectangle[ " << i << " ][ " << j << " ] = " << rectangle[i][j] << endl;
        }
    }

    bool solutionFound = false;
    int m = 1;
    for(m=1; m<=n ;m++){
        bool noSolutionInThisCase = false;
        for(int i=0; i<=n-m; i++){
            for(int j=0; j<=n-m; j++){
                long long sum = rectangle[i+m-1][j+m-1];
                sum -= rectangle[i+m-1][j-1];
                sum -= rectangle[i-1][j+m-1];
                sum += rectangle[i-1][j-1];

                //cout << "sum[ " << i << " ][ " << j << " ] = " << sum << endl;

                if(sum < minSum){
                    noSolutionInThisCase = true;
                    break;
                }
            }
            if(noSolutionInThisCase) break;
        }
        if(!noSolutionInThisCase){
            solutionFound = true;
            break;
        }
    }

    if(solutionFound){
        cout << m << endl;
    }
    else{
        cout << -1 << endl;
    }

    return 0;
}
